// ----------------------------------------------------------------------------
/*
 * Copyright (c) 2013 Lessmller Lasertechnik GmbH
 *  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
// ----------------------------------------------------------------------------
#include "fancy_console.h"

void header(char * text)
{
    unsigned char i = 0;
    unsigned char l = len(text);
    
    unsigned char v = (77-l) / 2;
    unsigned char h = v + ((77-l) % 2);

    //----------------------------------------
    printf("\r\n%c",218);                   //
    for (i=0;i<77;i++) printf("%c",196);    //
    printf("%c\r\n",191);                   //
    printf("%c",179);                       //
                                            //
    for (i=0;i<v;i++) printf("%c",32);      //
                                            //
    printf("%s",text);                      //
                                            //
    for (i=0;i<h;i++) printf("%c",32);      //
                                            //
    printf("%c\r\n",179);                   //
    printf("%c",192);                       //
    for (i=0;i<77;i++) printf("%c",196);    //
    printf("%c",217);                      //
    //----------------------------------------
}

void title(char * text)
{
    unsigned char i = 0;
    unsigned char l = len(text);
    
    unsigned char v = (77-l-2-11);

    printf("\r\n%c",195);                       
                                            
    printf("  %s",text);                    
    for (i=0; i<v; i++) printf("%c",32);
}

void separator(void)
{   
    printf("\r\n%c",195);
    for (unsigned char i=0;i<77;i++) printf("%c",196);
    printf("%c",180);
}

int len(char * string)
{
    int i = 0;
    while (string[++i] != '\0');
    return i;
}